/**
 * 一维数组变二维数组
 * @param list
 * @param elementsPerSubArray
 * @returns {Array}
 */
function arrayToMatrix(list, elementsPerSubArray) {
    var matrix = [], i, k;

    for (i = 0, k = -1; i < list.length; i++) {
        if (i % elementsPerSubArray === 0) {
            k++;
            matrix[k] = [];
        }

        matrix[k].push(list[i]);
    }

    return matrix;
}

/**
 * 根据映射关系将数组变为对象
 */
function arr2Object(arr, mapArr) {
    var obj = {};
    for (var i = 0; i < mapArr.length; i++) {
        obj[mapArr[i]]=arr[i];
    }
    return obj;
}

/**
 * 一个收入详情的字段
 */
INCOME_DETAIL_ARR=["type","name","unit","amount","price","taxRate"];
INCOME_DETAIL_PROP_LENGTH=8;

function saveIncome(url, data, projectId) {
    if(Array.isArray(data) && data.length != 0){
        var arr = arrayToMatrix(data,INCOME_DETAIL_PROP_LENGTH);
        console.log(arr);
        var incomeDetails = [];
        for (var i=0;i<arr.length;i++){
            incomeDetails.push(arr2Object(arr[i], INCOME_DETAIL_ARR));

        }
        var da = {
            "incomeDetails":incomeDetails,
            "projectId":projectId
        };
        $.ajax({
            url: url,
            data: JSON.stringify(da),
            type: "post",
            dataType: "json",
            contentType:"application/json",
            async: false,
            success: function (d) {
                console.log(d);
                //TODO 进行计算
            }
        });
    }
}